/**
 * org.vamsas.client.Iclient
 * 
 */
package org.vamsas.client;
Interface Iclient {
    /**
     * Define the methods availabable to a vamsas
     * application for interacting with the vamsas 
     * object broker
     * (it's VORBA, not CORBA!)
     */
    /**
     * static methods for returning a new instance 
     * of vorba with or without a session urn. 
     */
    Iclient getVorba(String ApplicationHandle);
    Iclient getVorba(String ApplicationHandle, String SessionUrn);
    /**
     * Extend to multi-user. By default is to use current username
     *
     * Iclient getVorba(String ApplicationHandle, String UserUrn);
     */

    /**
     * Instance methods
     */
    /**
     *  Return current SessionUrni
     */
    String getSessionUrn();
    /**
     * get vamsas document with app specific data
     */
    VamsasClientDocument getDocument();
    /**
     * register handler for updates for the current session
     */
    void addDocumentUpdateHandler(java.util.EventHandler evt);
    /**
     * Self-documenting/describing info for presenting to user
     * returns string like VamsasClient v.1.1.1 (GPL) and whatever
     */
    String getAboutVamsasClient();

    void closeVamsasDocument();

}
